#ifndef ETN_FPGA_MGR_FEATURES__H
#define ETN_FPGA_MGR_FEATURES__H

#include "fpgafeat.h"

/* See description in fpga_feature_descriptors array below */
#define FPGA_FEATURE_MX_FPGA_ID_STR      "MX_FPGA_ID"
#define FPGA_FEATURE_MX_PHY_STR          "MX_PHY"
#define FPGA_FEATURE_MX_STAT_STR         "MX_STAT"
#define FPGA_FEATURE_FLEX_FILT_STR       "FLEX_FILT"
#define FPGA_FEATURE_FLEX_FILT_PM_STR    "FLEX_FILT_PM"
#define FPGA_FEATURE_FLEX_FILT_RTP_STR   "FLEX_FILT_RTP"
#define FPGA_FEATURE_FS_FILT_STR         "FS_FILT"
#define FPGA_FEATURE_FIELDS_RPL_STR      "FIELDS_RPL"
#define FPGA_FEATURE_HTP_PACKER_STR      "HTP_PACKER"
#define FPGA_FEATURE_PKT_ENCAPS_STR      "PKT_ENCAPS"
#define FPGA_FEATURE_FLOW_GEN_STR        "FLOW_GEN"
#define FPGA_FEATURE_SIGN_ANLZ_STR       "SIGN_ANLZ"
#define FPGA_FEATURE_NIC_CPU_BUF_STR     "NIC_CPU_BUF"
#define FPGA_FEATURE_RMON_STAT_STR       "RMON_STAT"
#define FPGA_FEATURE_LB_STR              "LB"
#define FPGA_FEATURE_TWAMP_RX_FILT_STR   "TWAMP_RX_FILT"
#define FPGA_FEATURE_TWAMP_REFL_STR      "TWAMP_REFL"
#define FPGA_FEATURE_NIC_CTRL_STR        "NIC_CTRL"
#define FPGA_FEATURE_BERT_GEN_STR        "BERT_GEN"
#define FPGA_FEATURE_BERT_ANLZ_STR       "BERT_ANLZ"
#define FPGA_FEATURE_LCD_STR             "LCD"
#define FPGA_FEATURE_BEEPER_STR          "BEEPER"
#define FPGA_FEATURE_SOM_HWTEST_STR      "SOM_HWTEST"
#define FPGA_FEATURE_MPT_ANLZ_STR        "MPT_ANLZ"
#define FPGA_FEATURE_MPT_TX_STR          "MPT_TX"
#define FPGA_FEATURE_FAN_STR             "FAN"
#define FPGA_FEATURE_PTP_RTC_STR         "PTP_RTC"


/* Supported FPGA features names. */
static const char *fpga_feature_names[] = {
	[ FPGA_FEATURE_MX_FPGA_ID ]    = FPGA_FEATURE_MX_FPGA_ID_STR,
	[ FPGA_FEATURE_MX_PHY ]        = FPGA_FEATURE_MX_PHY_STR,
	[ FPGA_FEATURE_MX_STAT ]       = FPGA_FEATURE_MX_STAT_STR,
	[ FPGA_FEATURE_FLEX_FILT ]     = FPGA_FEATURE_FLEX_FILT_STR,
	[ FPGA_FEATURE_FLEX_FILT_PM  ] = FPGA_FEATURE_FLEX_FILT_PM_STR,
	[ FPGA_FEATURE_FLEX_FILT_RTP ] = FPGA_FEATURE_FLEX_FILT_RTP_STR,
	[ FPGA_FEATURE_FS_FILT ]       = FPGA_FEATURE_FS_FILT_STR,
	[ FPGA_FEATURE_FIELDS_RPL ]    = FPGA_FEATURE_FIELDS_RPL_STR,
	[ FPGA_FEATURE_HTP_PACKER ]    = FPGA_FEATURE_HTP_PACKER_STR,
	[ FPGA_FEATURE_PKT_ENCAPS ]    = FPGA_FEATURE_PKT_ENCAPS_STR,
	[ FPGA_FEATURE_FLOW_GEN ]      = FPGA_FEATURE_FLOW_GEN_STR,
	[ FPGA_FEATURE_SIGN_ANLZ ]     = FPGA_FEATURE_SIGN_ANLZ_STR,
	[ FPGA_FEATURE_NIC_CPU_BUF ]   = FPGA_FEATURE_NIC_CPU_BUF_STR,
	[ FPGA_FEATURE_RMON_STAT ]     = FPGA_FEATURE_RMON_STAT_STR,
	[ FPGA_FEATURE_LB ]            = FPGA_FEATURE_LB_STR,
	[ FPGA_FEATURE_TWAMP_RX_FILT ] = FPGA_FEATURE_TWAMP_RX_FILT_STR,
	[ FPGA_FEATURE_TWAMP_REFL ]    = FPGA_FEATURE_TWAMP_REFL_STR,
	[ FPGA_FEATURE_NIC_CTRL ]      = FPGA_FEATURE_NIC_CTRL_STR,
	[ FPGA_FEATURE_BERT_GEN ]      = FPGA_FEATURE_BERT_GEN_STR,
	[ FPGA_FEATURE_BERT_ANLZ ]     = FPGA_FEATURE_BERT_ANLZ_STR,
	[ FPGA_FEATURE_LCD ]           = FPGA_FEATURE_LCD_STR,
	[ FPGA_FEATURE_BEEPER ]        = FPGA_FEATURE_BEEPER_STR,
        [ FPGA_FEATURE_SOM_HWTEST ]    = FPGA_FEATURE_SOM_HWTEST_STR,
        [ FPGA_FEATURE_MPT_ANLZ ]      = FPGA_FEATURE_MPT_ANLZ_STR,
	[ FPGA_FEATURE_MPT_TX ]        = FPGA_FEATURE_MPT_TX_STR,
	[ FPGA_FEATURE_FAN    ]        = FPGA_FEATURE_FAN_STR,
	[ FPGA_FEATURE_PTP_RTC ]       = FPGA_FEATURE_PTP_RTC_STR,
	NULL
};

/* Supported FPGA features descriptions. */
static const char *fpga_feature_descriptors[] = {
	[ FPGA_FEATURE_MX_FPGA_ID ]    = "Features descriptor",
	[ FPGA_FEATURE_MX_PHY ]        = "Low-level access to physical periphery",
	[ FPGA_FEATURE_MX_STAT ]       = "MX statistics support",
	[ FPGA_FEATURE_FLEX_FILT ]     = "Flexible filters support",
	[ FPGA_FEATURE_FLEX_FILT_PM  ] = "Pattern-match filters extension support",
	[ FPGA_FEATURE_FLEX_FILT_RTP ] = "RTP/RTCP filters extension support",
	[ FPGA_FEATURE_FS_FILT ]       = "Field-split filters support",
	[ FPGA_FEATURE_FIELDS_RPL ]    = "Fields replacing support",
	[ FPGA_FEATURE_HTP_PACKER ]    = "Header Transfer Protocol support",
	[ FPGA_FEATURE_PKT_ENCAPS ]    = "Packet encapsulation support",
	[ FPGA_FEATURE_FLOW_GEN ]      = "Flow generators support",
	[ FPGA_FEATURE_SIGN_ANLZ ]     = "Traffic analyzer support",
	[ FPGA_FEATURE_NIC_CPU_BUF ]   = "Network interface controller CPU buffer",
	[ FPGA_FEATURE_RMON_STAT ]     = "Port statistic (RMON) support",
	[ FPGA_FEATURE_LB ]            = "Smart Loopback support",
	[ FPGA_FEATURE_TWAMP_RX_FILT ] = "TWAMP rx filters support",
	[ FPGA_FEATURE_TWAMP_REFL ]    = "TWAMP reflector support",
	[ FPGA_FEATURE_NIC_CTRL ]      = "Network interface controller support",
	[ FPGA_FEATURE_BERT_GEN ]      = "BERT generator support",
	[ FPGA_FEATURE_BERT_ANLZ ]     = "BERT analyzer support",
	[ FPGA_FEATURE_LCD ]           = "LCD support",
	[ FPGA_FEATURE_BEEPER ]        = "Beeper support",
        [ FPGA_FEATURE_SOM_HWTEST ]    = "SOM hardware tests support",
        [ FPGA_FEATURE_MPT_ANLZ ]      = "MPT analyzer support",
	[ FPGA_FEATURE_MPT_TX ]        = "MPT generator support",
	[ FPGA_FEATURE_FAN    ]        = "FAN control support",
	[ FPGA_FEATURE_PTP_RTC ]       = "PTP support",
	NULL
};

#endif // ETN_FPGA_MGR_FEATURES__H
