#ifndef ETN_NET_MAIN__H
#define ETN_NET_MAIN__H

#include <linux/netdevice.h>
#include "net.h"

#define DRV_NAME "etn_net"

#ifndef DRV_VERSION
#define DRV_VERSION "1.0.9"
#endif


struct fpga_regs {
	int cr;
	int sr;
};

struct etn_netdev {
	struct net_device *netdev;
	struct platform_device *pdev;

	struct fpga_io *io;
	void __iomem *regs_base;

	struct fpga_regs dma;
	struct fpga_regs nic;
	struct fpga_regs phy;

	struct mutex macphy_lock;

	struct mii_bus *mdio_bus;
	struct phy_device *phy_dev;

	struct napi_struct napi;
	struct work_struct restart_work;

	struct fpga_rx_buff rx_ring[RX_DESC_FIFO_DEPTH];
	struct fpga_tx_buff tx_ring[TX_DESC_FIFO_DEPTH];

	int port_num;
	u32 msg_enable;

	int old_link;
	// Fiber or copper
	int old_port;
	int old_speed;
	int old_duplex;

	unsigned int rx_head;
	unsigned int rx_tail;

	unsigned int tx_head;
	unsigned int tx_tail;

	unsigned int rx_data_size;

	struct delayed_work phy_dwork;
};

void etn_net_check_mac_address(struct etn_netdev *etn_port);

#endif // ETN_NET_MAIN__H
