#ifndef ETN_NET_NET__H
#define ETN_NET_NET__H

#include <linux/netdevice.h>
#include "alt_msgdma.h"

#define RX_DESC_FIFO_DEPTH              64
#define TX_DESC_FIFO_DEPTH              64

/* The width of RX/TX FIFO is specified in terms of 8-bit bytes. */
#define SC_FIFO_WIDTH                   8
#define SC_FIFO_DEPTH                   2048

#define MSGDMA_BASE_PORT0               0x00002000
#define MSGDMA_BASE_PORT1               0x00002140

#define MSGDMA_TX_CSR                   0x00
#define MSGDMA_TX_DESC_FIFO             0x40
#define MSGDMA_RX_CSR                   0x80
#define MSGDMA_RX_DESC_FIFO             0xC0
#define MSGDMA_RX_RESPONSE              0x100

// TODO:
//   Remove hardcode
#define NIC_CR_PORT0 76
#define NIC_SR_PORT0 84

#define NIC_CR_PORT1 80
#define NIC_SR_PORT1 85

#define HOST_MAC_W0_CR   0

// Netwotk settings
#define ETH_JUMBO_MTU   1520
#define PCIE_AVMM_TXS      0
#define NAPI_WEIGHT       64


struct fpga_rx_buff {
	struct sk_buff *skb;
	dma_addr_t dma_addr;
};

struct fpga_tx_buff {
	struct sk_buff *skb;
	dma_addr_t dma_addr;
	struct alt_msgdma_extended_descriptor desc;
};

extern const struct net_device_ops etn_netdev_ops;
extern const struct ethtool_ops etn_ethtool_ops;

int etn_net_poll(struct napi_struct *napi, int budget);
void etn_net_restart_work(struct work_struct *work);

#endif // ETN_NET_NET__H
